<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfMyTransicsUser ArrayType
 * @subpackage Arrays
 */
class ArrayOfMyTransicsUser extends AbstractStructArrayBase
{
    /**
     * The MyTransicsUser
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\MyTransicsUser[]
     */
    public $MyTransicsUser;
    /**
     * Constructor method for ArrayOfMyTransicsUser
     * @uses ArrayOfMyTransicsUser::setMyTransicsUser()
     * @param \StructType\MyTransicsUser[] $myTransicsUser
     */
    public function __construct(array $myTransicsUser = array())
    {
        $this
            ->setMyTransicsUser($myTransicsUser);
    }
    /**
     * Get MyTransicsUser value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\MyTransicsUser[]|null
     */
    public function getMyTransicsUser()
    {
        return isset($this->MyTransicsUser) ? $this->MyTransicsUser : null;
    }
    /**
     * This method is responsible for validating the values passed to the setMyTransicsUser method
     * This method is willingly generated in order to preserve the one-line inline validation within the setMyTransicsUser method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateMyTransicsUserForArrayConstraintsFromSetMyTransicsUser(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfMyTransicsUserMyTransicsUserItem) {
            // validation for constraint: itemType
            if (!$arrayOfMyTransicsUserMyTransicsUserItem instanceof \StructType\MyTransicsUser) {
                $invalidValues[] = is_object($arrayOfMyTransicsUserMyTransicsUserItem) ? get_class($arrayOfMyTransicsUserMyTransicsUserItem) : sprintf('%s(%s)', gettype($arrayOfMyTransicsUserMyTransicsUserItem), var_export($arrayOfMyTransicsUserMyTransicsUserItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The MyTransicsUser property can only contain items of type \StructType\MyTransicsUser, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set MyTransicsUser value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\MyTransicsUser[] $myTransicsUser
     * @return \ArrayType\ArrayOfMyTransicsUser
     */
    public function setMyTransicsUser(array $myTransicsUser = array())
    {
        // validation for constraint: array
        if ('' !== ($myTransicsUserArrayErrorMessage = self::validateMyTransicsUserForArrayConstraintsFromSetMyTransicsUser($myTransicsUser))) {
            throw new \InvalidArgumentException($myTransicsUserArrayErrorMessage, __LINE__);
        }
        if (is_null($myTransicsUser) || (is_array($myTransicsUser) && empty($myTransicsUser))) {
            unset($this->MyTransicsUser);
        } else {
            $this->MyTransicsUser = $myTransicsUser;
        }
        return $this;
    }
    /**
     * Add item to MyTransicsUser value
     * @throws \InvalidArgumentException
     * @param \StructType\MyTransicsUser $item
     * @return \ArrayType\ArrayOfMyTransicsUser
     */
    public function addToMyTransicsUser(\StructType\MyTransicsUser $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\MyTransicsUser) {
            throw new \InvalidArgumentException(sprintf('The MyTransicsUser property can only contain items of type \StructType\MyTransicsUser, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->MyTransicsUser[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\MyTransicsUser|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\MyTransicsUser|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\MyTransicsUser|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\MyTransicsUser|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\MyTransicsUser|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string MyTransicsUser
     */
    public function getAttributeName()
    {
        return 'MyTransicsUser';
    }
}
